#!/usr/bin/perl

# vsender.init.pl
# ===============
# [Spamassassin Plugin that check if sender recipient is able to accept mail]

# Initial creation of vsender table using sqlite


use DBI;
use Data::Dumper;

my $driver   = "SQLite";
my $database = "vsender.db";
my $dsn = "DBI:$driver:dbname=$database";

print "\n[HOW TO]\n";
print "All files must be on a folder  named 'vsender' under spamassassin folder\n";
print "This folder must be available in writing to spamassassin user (probably is 'postfix')\n";
print "Also Db file must be writable by this user\n";
print "To activate plugin create a synlink of cf file with this command fron spamassassin folder:\n";
print "ln -s  vsender/vsender.cf vsender.cf\n";
print "To test entries in vsender.db:\n";
print "echo \"SELECT * FROM vsender;\" | sqlite3 vsender.db \n\n";
print "echo \"SELECT * FROM vsendergrey;\" | sqlite3 vsender.db \n\n";

if( ! -f $database ){
  print "New database, creating table...\n";
  my $dbh = DBI->connect($dsn, "", "", { RaiseError => 1 }) or diei $DBI::errstr;
  my $stmt = "CREATE TABLE vsender (timestamp timestamp DEFAULT CURRENT_TIMESTAMP not null, vfrom char(255) not null, vok bool not null, PRIMARY KEY(vfrom));";
  my $rv = $dbh->do($stmt) or die $DBI::errstr;
  my $stmt = "CREATE TABLE vsendergrey (timestamp timestamp DEFAULT CURRENT_TIMESTAMP not null, vdomain char(255) not null, PRIMARY KEY(vdomain));";
  my $rv = $dbh->do($stmt) or die $DBI::errstr;
  print " *** Database and table created !\n  Please chown and/or chmod $database and its folder\n\n";
} else {
  print " *** Database $database already exists\n\n";
}
 
